use File::Basename; 
use File::Copy; 

use File::Slurp; 
use File::Spec; 
use IO::All; 
use POSIX 'strftime'; 
use Cwd qw(); 
use strict; 
use Fcntl ':mode'; 

########################################
# Start log 
my $log_file = 'aleph_24_mft_patch.log'; 
open(my $log_fh, '>', $log_file) 
  or die "Could not create the log '$log_file' $!"; 

my $revert_files_log_file = 'aleph_24_mft_patch_revert_files.log'; 
open(my $revert_files_log_fh, '>', $revert_files_log_file) 
  or die "Could not create the log '$revert_files_log_file' $!"; 

#
########################################

########################################
########################################
# Current dir
my $orig_source_path = Cwd::cwd(); 
print $log_fh "----------------------------------------\n"; 
print $log_fh "$orig_source_path\n\n"; 

my $aleph_dev   = $ENV{'aleph_dev'};    print $log_fh "$aleph_dev\n"; 

my $aleph_proc = $ENV{'aleph_proc'};  print $log_fh "$aleph_proc\n"; 

my $date_time = strftime '%Y%m%d%H%M', localtime; 
print $log_fh "\$date_time $date_time \n\n"; 

my $aleph_version = $ENV{'ALEPH_VERSION'}; print $log_fh "ALEPH_VERSION $aleph_version\n"; 
print "ALEPH_VERSION $aleph_version\n"; 

#
########################################
########################################

# ./aleph/proc/util_sp_ftp 
my $orig_util_sp_ftp = "$aleph_proc/util_sp_ftp"; 
my $orig_util_sp_ftp_backup = "$aleph_proc/util_sp_ftp".'.'."$date_time"; 
 
print "$orig_util_sp_ftp\n"; 
print "$orig_util_sp_ftp_backup\n"; 

my $new_util_sp_ftp = "$orig_source_path/util_sp_ftp"; ## Should be extracted. 

if (!-e $orig_util_sp_ftp){ 
  print "  ERROR: NO file $$orig_util_sp_ftp \n\n"; 
} elsif ( -e $orig_util_sp_ftp){ 
  copy ($orig_util_sp_ftp, $orig_util_sp_ftp_backup) 
    or die "Copy failed: $!" ; 
  print "Copied $orig_util_sp_ftp \t to \t $orig_util_sp_ftp_backup \n\n"; 
  print $log_fh "Copied $orig_util_sp_ftp \t to \t $orig_util_sp_ftp_backup \n\n"; 

  print "To revert:  cp $orig_util_sp_ftp_backup $orig_util_sp_ftp  \n\n"; 
  print $log_fh "To revert:  cp $orig_util_sp_ftp_backup $orig_util_sp_ftp   \n\n"; 
  print $revert_files_log_fh "  cp  $orig_util_sp_ftp_backup $orig_util_sp_ftp \n"; 
} 

print $log_fh "------------------------------\n"; 
print $log_fh "------------------------------\n\n\n"; 

print         "------------------------------\n"; 
print         "------------------------------\n"; 

########################################
########################################

chdir $orig_source_path ; 

 `pwd` ;

########################################
### Close log 
close $log_fh; 
### End close log
########################################
